<?php
class invoice_ctl_admin_channel extends desktop_controller{
    
    public function __construct($app){
        parent::__construct($app);
    }
    
    //列表
    function index(){
        $params = array(
           'title' => '电子发票来源列表',
           'use_buildin_import' => false,
           'use_buildin_recycle' => false,
           'actions' => array(
                array(
                  'label' => '添加来源',
                  'href' => 'index.php?app=invoice&ctl=admin_channel&act=add',
                  'target' => 'dialog::{width:500,height:210,title:\'添加来源\'}',
                ),
           )
        );
        $this->finder('invoice_mdl_channel', $params);
    }
    
    //新增
    function add(){
       $this->_edit('add');
    }
    
    //编辑
    function edit($channel_id){
       $this->_edit('edit',$channel_id);
    }
    
    //新增/编辑的界面呼出
    function _edit($action,$channel_id = ""){
        $mdlInChannel = app::get('invoice')->model('channel');
       //来源类型信息
       $funcObj = kernel::single('invoice_func');
       $channels = $funcObj->channels();
       $this->pagedata['channels'] = $channels;
       //获取来源店铺列表 目前只支持淘系的店铺
       $shopSql = "SELECT shop_id,name FROM sdb_ome_shop WHERE node_type='taobao' and node_id IS NOT NULL";
       $shopList = $mdlInChannel->db->select($shopSql);
       if($channel_id && $action == "edit"){
          $this->pagedata['channel'] = $mdlInChannel->dump(array('channel_id'=>$channel_id));
       }
       $this->pagedata['shopList'] = $shopList;
       $this->pagedata['action_type'] = $action;
       $this->display("admin/channel.html");
    }
    
    //新增或者更新操作
    function do_save(){
        $this->begin('javascript:finderGroup["'.$_GET['finder_id'].'"].refresh();');
        if(!$_POST['name']){
            $this->end(false, '请填写来源名称');
        }
        if(!$_POST['channel_type']){
            $this->end(false, '请选择来源类型');
        }
        $update_data = array(
            "shop_id" => $_POST['shop_id'],
            "name" => $_POST['name'],
            "channel_type" => $_POST['channel_type'],
            "create_time" => time(),
        );
        if($_POST['channel_id'] && $_POST['action_type'] == "edit"){
            //编辑保存操作
            $update_data['channel_id'] = $_POST['channel_id'];
        }else{
            //只添加判断
            if(!$_POST['shop_id']){
                $this->end(false, '请选择关联店铺');
            }

            //电子发票来源添加时，识别淘系店铺订阅消息添加分组
            if($_POST['channel_type'] == 'taobao'){
                $is_tb_group_bind = false;
                $bind_key = sprintf('invoice_bind_tbgroup_%s',$_POST['shop_id']);

                //检查当前是否已绑定分组
                base_kvstore::instance('invoice/bind/tbgroup')->fetch($bind_key, $is_tb_group_bind);
                if (!$is_tb_group_bind) {
                    $bind_status = kernel::single('invoice_event_trigger_einvoice')->bindTbTmcGroup($_POST['shop_id'], $update_data);
                    if ( $bind_status == true) {
                        base_kvstore::instance('invoice/bind/tbgroup')->store($bind_key, true);
                        $update_data['status'] = 'true';
                    }else{
                        $update_data['status'] = 'false';
                    }
                }
            }
        }
        $mdlInChannel = app::get('invoice')->model('channel');
        $mdlInChannel->save($update_data);
        $this->end(true, '新建成功');
    }
    
    //启用、暂停状态切换
    public function status($status,$channel_id){
        $this->begin('javascript:finderGroup["'.$_GET['finder_id'].'"].refresh();');
        if(!$channel_id){
            $this->end(false,$this->app->_('设置失败'));
        }
        $mdlInChannel = $this->app->model('channel');
        $mdlInOrderSet = $this->app->model('order_setting');
        
        $filter = array('channel_id'=>$channel_id);
        
        $rs = $mdlInOrderSet->dump($filter);
        if(!empty($rs) && $status == "false"){
            $this->end(false,'该来源已被使用，不能暂停！');
        }

        $channelInfo = $mdlInChannel->dump($filter);
        //电子发票来源添加时，识别淘系店铺订阅消息添加分组
        if($channelInfo['channel_type'] == 'taobao'){
            $bind_key = sprintf('invoice_bind_tbgroup_%s',$channelInfo['shop_id']);
            //绑定
            if($status == 'true'){
                $bind_status = kernel::single('invoice_event_trigger_einvoice')->bindTbTmcGroup($channelInfo['shop_id'], $channelInfo);
                if ( $bind_status == true) {
                    base_kvstore::instance('invoice/bind/tbgroup')->store($bind_key, true);
                }else{
                    $this->end(false,$this->app->_('设置失败'));
                }
            }else{
                //解绑
                $unbind_status = kernel::single('invoice_event_trigger_einvoice')->unbindTbTmcGroup($channelInfo['shop_id'], $channelInfo);
                if ( $unbind_status == true) {
                    base_kvstore::instance('invoice/bind/tbgroup')->store($bind_key, false);
                }else{
                    $this->end(false,$this->app->_('设置失败'));
                }
            }
        }

        $data = array(
            "status" => $status
        );
        $mdlInChannel->update($data,$filter);
        $this->end(true,$this->app->_('设置成功'));
    }
    
}
