<?php
/**
 +----------------------------------------------------------
 * 订单发票设置
 +----------------------------------------------------------
 * Author: ExBOY
 * Time: 2014-03-18 $  20170331更新by wangjianjun
 * [Ecos!] (C)2003-2014 Shopex Inc.
 +----------------------------------------------------------
 */
class invoice_ctl_admin_order_setting extends desktop_controller{
    
    function index(){
        $params = array(
                'title' => '开票信息配置',
                'allow_detail_popup' => true,
                'use_buildin_recycle' => false,
                'orderBy' => 'mode asc'
        );
        $params['actions'] =array(
                array(
                    'label'=>'添加配置',
                    'href'=>'index.php?app=invoice&ctl=admin_order_setting&act=add',
                    'target' => 'dialog::{width:780,height:800,title:\'添加开票信息配置\'}',
                ),
        );
        $this->finder('invoice_mdl_order_setting', $params);
    }
    
    //新增弹窗页
    function add(){
        $this->_edit("add");
    }
    
    //编辑弹窗页
    function edit($sid){
        $this->_edit("edit",$sid);
    }
    
    //新增和编辑弹窗页的展示
    function _edit($action,$sid = ""){
        $mdlOmeShop = app::get('ome')->model('shop');
        $mdlInOrderSet = $this->app->model('order_setting');
        $mdlInChannels = $this->app->model('channel');
        $mdlInSetShopIdRel = $this->app->model('setting_shopid_relation');
        $this->pagedata['shopData'] = $mdlOmeShop->getList();//获取前端店铺列表
        $this->pagedata['action_type'] = $action;//add或者edit
        $this->pagedata['invoice_mode'] = $mdlInOrderSet->schema["columns"]["mode"]["type"];//开票方式
        $this->pagedata['channels'] = $mdlInChannels->getList('*',array('status'=>'true'));//开票来源
        $this->pagedata['invoice_content'] = kernel::single('invoice_common')->getInvoiceContent();//发票内容列表
        //默认add时此item为空
        $this->pagedata['item'] = array();
        $order_setting_filter = array();
        if($sid){
            //edit时获取数据
            $this->pagedata['item'] = $mdlInOrderSet->dump(array('sid'=>$sid));
            //已存在关系的shop_id
            $rs_select_shopids = $mdlInSetShopIdRel->getList("shop_id",array("sid"=>$sid));
            foreach ($rs_select_shopids as $var_ss){
                $select_shopids[] = $var_ss["shop_id"];
            }
            $this->pagedata['item']["shopids"] = $select_shopids;
            $order_setting_filter["sid|noequal"] = $sid;
        }
        //找到已经被其他来源选中的店铺
        $used_shopids = $mdlInSetShopIdRel->getList("shop_id",$order_setting_filter);
        if (!empty($used_shopids)){
            foreach($used_shopids as $var_u_s){
                $used_shop_ids[$var_u_s["shop_id"]] = $var_u_s["shop_id"];
            }
        }
        $this->pagedata['used_shop_ids'] = $used_shop_ids;
        $this->page('admin/edit.html');
    }
    
    //新增和编辑操作
    function save(){
        $this->begin('javascript:finderGroup["'.$_GET['finder_id'].'"].refresh();');
        if (!$_POST["action_type"] || ($_POST["action_type"] == "edit" && !$_POST["item"]["sid"])){
            $this->end(false, '操作失败');
        }
        $update_data = $_POST["item"];
        if(empty($update_data['shopids'])){
            $this->end(false, '操作失败,请选择应用开票店铺。');
        }
        
        $mdlOmeShop = app::get('ome')->model('shop');
        $mdlInOrderSet = $this->app->model('order_setting');
        $mdlInSetShopIdRel = $this->app->model('setting_shopid_relation');
        $mdlInChannel= $this->app->model('channel');
        
        //获取选中的应用店铺ids
        $shop_ids = array();
        foreach ($update_data['shopids'] as $var_si){
            if($var_si == '_ALL_'){
                //选中所有店铺的checkbox 跳过
                continue;
            }
            $shop_ids[] = $var_si;
        }
        unset($update_data['shopids']);
        
        $check_channel_id = false;
        if($update_data["mode"] == "1"){//电子发票
            if (!$update_data["channel_id"]){
                $this->end(false, '请选择开票来源');
            }
            $check_channel_id = true;
            $channe_info = $mdlInChannel->dump(array("channel_id"=>$update_data["channel_id"]));
            $update_data['shop_id'] = $channe_info['shop_id'];
            $shop_info = $mdlOmeShop->dump(array('shop_id'=>$update_data['shop_id']));
            $update_data['billing_shop_node_id'] = $shop_info['node_id'];
        }else{//纸质发票
            $update_data["channel_id"] = NULL;
            $update_data["shop_id"] = NULL;
            $update_data["billing_shop_node_id"] = NULL;
            unset($update_data["einvoice_operating_conditions"],$update_data["auto_bill"],$update_data["auto_bill_timer"]);
        }
        
        $rel_filter = array("shop_id"=>$shop_ids);
        $setting_filter = array("channel_id"=>$update_data["channel_id"]);
        if ($_POST["action_type"] == "add"){//新增
            unset($update_data["sid"]);
        }else{//编辑
            $rel_filter["sid|noequal"] = $update_data["sid"];
            $setting_filter["sid|noequal"] = $update_data["sid"];
        }
        $rs_rel = $mdlInSetShopIdRel->getList("*",$rel_filter);
        if(!empty($rs_rel)){
            $this->end(false, '操作失败,有店铺已被使用。');
        }
        if($check_channel_id){
            $rs_channel = $mdlInOrderSet->dump($setting_filter);
            if(!empty($rs_channel)){
                $this->end(false, '该开票来源已被使用');
            }
        }
        $update_data['dateline'] = time();
        $result = $mdlInOrderSet->save($update_data);
        if($result){
            if($update_data["sid"] && $_POST["action_type"] == "edit"){//编辑
                $sid = $update_data["sid"];
            }else{//新增
                $sid = $mdlInOrderSet->db->lastInsertId();
            }
            $this->do_rel_setting_shopid($sid,$shop_ids,$_POST["action_type"]);
           	$this->end(true, '新建成功');
        }else{
            $this->end(false, '新建失败');
        }
    }
    
    //新增或者编辑时处理sid和shopid的关系
    function do_rel_setting_shopid($sid,$shop_ids,$action_type){
        $mdlInSetShopIdRel = $this->app->model('setting_shopid_relation');
        if ($action_type == "add"){//新增直接加关系
            foreach ($shop_ids as $var_shop_id){
                $insert_arr = array("sid"=>$sid,"shop_id"=>$var_shop_id);
                $mdlInSetShopIdRel->insert($insert_arr);
            }
        }else{//编辑 保留已存在的关系 删除去除的关系 新增新加的关系
            $rs_old = $mdlInSetShopIdRel->getList("*",array("sid"=>$sid));   
            $keep_shop_ids = array();
            foreach ($rs_old as $var_r_o){
                if (in_array($var_r_o["shop_id"],$shop_ids)){
                    $keep_shop_ids[] = $var_r_o["shop_id"];
                }else{
                    $delete_arr = array("sid"=>$sid,"shop_id"=>$var_r_o["shop_id"]);
                    $mdlInSetShopIdRel->delete($delete_arr);
                }
            }
            $insert_shop_ids = array();
            foreach($shop_ids as $var_s_i){
                if(!in_array($var_s_i,$keep_shop_ids)){
                    $insert_arr = array("sid"=>$sid,"shop_id"=>$var_s_i);
                    $mdlInSetShopIdRel->insert($insert_arr);
                }
            }
        }
    }
    
    //启用、暂停状态切换
    public function status($status,$sid = null){
        $this->begin('javascript:finderGroup["'.$_GET['finder_id'].'"].refresh();');
        if(!$sid){
            $this->end(false,$this->app->_('设置失败'));
        }
        $mdlInOrderSet = $this->app->model('order_setting');
        $filter = array("sid"=>$sid);
        $data = array(
            "status" => $status
        );
        $mdlInOrderSet->update($data,$filter);
        $this->end(true,$this->app->_('设置成功'));
    }
    
}