<?php
$db['order']=array(
    'columns' =>
        array(
            'id' => array(
                'type' => 'int(10)',
                'pkey' => true,
                'extra' => 'auto_increment',
                'required' => true,
                'label' => '主键id',
                'in_list' => false,
                'default_in_list' => false,
            ),
            'order_id' => array(
                'type' => 'int(11)',
                'default' => '0',
                'required' => true,
                'label' => '订单id',
                'in_list' => false,
                'default_in_list' => false,
            ),
            'order_bn' => array(
                'type' => 'varchar(32)',
                'required' => true,
                'label' => '订单号',
                'is_title' => true,
                'searchtype' => 'nequal',
                'filterdefault' => true,
                'in_list' => true,
                'default_in_list' => true,
                'width' => 160,
                'order'=>2,
            ),
            'type_id' => array(
                'type' => array(
                    0=>'普通发票',
                    1=>'专业发票',
                ),
                'default' => '0',
                'label' => '纸质发票类型',
                'in_list' => true,
                'default_in_list' => false,
                'width' => 70,
            ),
            'mode' => array(
                'type' => array(
                    0=>'纸质发票',
                    1=>'电子发票',
                ),
                'default' => '0',
                'required' => true,
                'label' => '开票方式',
                'in_list' => true,
                'default_in_list' => true,
                'order'=>3,
                'width' => 70,
            ),
            'amount' => array(
                'type' => 'money',
                'default' => '0',
                'required' => true,
                'label' => '开票金额',
                'filtertype' => 'number',
                'filterdefault' => true,
                'in_list' => true,
                'default_in_list' => true,
                'order'=>4,
                'width' => 80,
            ),
            'cost_tax' => array(
                'type' => 'money',
                'default' => '0',
                'required' => true,
                'label' => '税金',
                'in_list' => true,
                'default_in_list' => true,
                'order'=>5,
                'width' => 80,
            ),
            'tax_rate' => array(
                'type' => 'tinyint(2)',
                'default' => '0',
                'required' => true,
                'label' => '税率',
                'in_list' => true,
                'default_in_list' => false,
                'width' => 50,
            ),
            'title' => array(
                'type' => 'varchar(150)',
                'label' => '发票抬头',
                'in_list' => true,
                'default_in_list' => false,
                'order'=>6,
                'width'=>90,
            ),
            'is_status' => array(
                'type' => array(
                    0=>'未开票',
                    1=>'已开票',
                    2=>'已作废',
                ),
                'default' => '0',
                'required' => true,
                'label' => '开票状态',
                'in_list' => true,
                'default_in_list' => true,
                'order'=> 7,
                'width' => 70,
            ),
            'sync' => array(
                'type' => array(
                    0=>'未同步',
                    1=>'开蓝票中',
                    2=>'开蓝失败',
                    3=>'开蓝成功',
                    4=>'开红票中',
                    5=>'冲红失败',
                    6=>'冲红成功',
                ),
                'label' => '状态同步',
                'default' => '0',
            ),
            'is_print' => array(
                'type' => array(
                    0=>'否',
                    1=>'是',
                ),
                'default' => '0',
                'label' => '打印',
            ),            
            'invoice_code' => array(
                'type' => 'varchar(32)',
                'label' => '发票代码',
                'in_list' => true,
                'default_in_list' => false,
                'width' => 60,
            ),
            'invoice_no' => array(
                'type' => 'varchar(32)',
                'label' => '发票号码',
                'in_list' => true,
                'default_in_list' => false,
                'width' => 60,
            ),
            'content_id' => array(
                'type' => 'varchar(10)',
                'default' => '1',
                'label' => '发票内容',
                'in_list' => true,
                'default_in_list' => false,
                'order'=>10,
            ),
            'remarks' => array(
                'type' => 'text',
                'label' => '发票备注',
                'in_list' => true,
                'default_in_list' => false,
            ),
            'operator' => array(
                'type' => 'mediumint(8)',
                'default' => '0',
                'required' => true,
                'in_list' => true,
                'default_in_list' => false,
                'label' => '操作人',
            ),
            'print_num' => array(
                'type' => 'smallint(6)',
                'default' => '0',
                'label' => '打印次数',
            ),
            'create_time' => array(
                'type' => 'time',
                'default' => '0',
                'label' => '创建时间',
                'filtertype' => 'time',
                'filterdefault' => true,
                'in_list' => true,
                'default_in_list' => true,
                'width' => 130,
            ),
            'dateline' => array(
                'type' => 'time',
                'default' => '0',
                'label' => '开票时间',
                'filtertype' => 'time',
                'filterdefault' => true,
                'in_list' => true,
                'default_in_list' => false,
                'width' => 130,
            ),
            'update_time' => array(
                'type' => 'int(10)',
                'default' => '0',
                'required' => true,
                'label' => '更新时间',
            ),
            'tax_company' => array(
                'type' => 'varchar(50)',
                'label' => '客户名称',
                'in_list' => true,
                'default_in_list' => false,
            ),
            'business_type' => array(
                'type' => 'tinyint(1)',
                'default' => '0',
                'label' => '客户类型',
                'in_list' => true,
                'default_in_list' => false,
            ),
            'ship_area' => array(
                'type' => 'varchar(100)',
                'label' => '客户收货地区',
            ),
            'ship_addr' => array(
                'type' => 'varchar(255)',
                'label' => '客户地址',
            ),
            'ship_tel' => array(
                'type' => 'char(32)',
                'label' => '客户电话',
                'in_list' => true,
                'default_in_list' => false,
            ),
            'ship_tax' => array(
                'type' => 'varchar(32)',
                'label' => '客户税号',
                'in_list' => true,
                'default_in_list' => false,
            ),
            'ship_bank' => array(
                'type' => 'varchar(32)',
                'label' => '客户开户银行',
                'in_list' => true,
                'default_in_list' => false,
            ),
            'ship_bank_no' => array(
                'type' => 'char(32)',
                'label' => '客户银行账号',
                'in_list' => true,
                'default_in_list' => false
            ),
            'shop_id' => array(
                'type' => 'table:shop@ome',
                'required' => true,
                'editable' => false,
                'label' => '来源店铺',
                'in_list' => true,
                'default_in_list' => true,
                'filtertype' => 'normal',
                'filterdefault' => true,
                'order' => 11,
            ),
            'payee_name' => array(
                'type' => 'varchar(100)',
                'label' => '开票方名称',
                'in_list' => true,
                'default_in_list' => false,
                'width' => 80,
            ),
            'tax_no' => array(
                'type' => 'varchar(32)',
                'label' => '开票方税号',
                'in_list' => true,
                'default_in_list' => false,
                'width' => 80,
            ),
            'address' => array(
                'type' => 'varchar(255)',
                'label' => '开票方地址',
                'in_list' => true,
                'default_in_list' => false,
                'width' => 60,
            ),
            'telephone' => array(
                'type' => 'char(32)',
                'label' => '开票方电话',
                'in_list' => true,
                'default_in_list' => false,
                'width' => 60,
            ),
            'payee_operator' => array(
                'type' => 'varchar(50)',
                'label' => '开票人',
                'in_list' => true,
                'default_in_list' => false,
                'width' => 60,
            ),
            'bank' => array(
                'type' => 'varchar(32)',
                'label' => '开票方开户银行',
                'in_list' => true,
                'default_in_list' => false,
                'width' => 80,
            ),
            'bank_no' => array(
                'type' => 'char(32)',
                'label' => '开票方银行账号',
                'in_list' => true,
                'default_in_list' => false,
                'width' => 80,
            ),
    ),
    'index' => array(
        'idx_status' => array(
            'columns'=>array(
                0=>'is_status',
            ),
        ),
        'idx_mode' => array(
            'columns'=>array(
                0=>'mode',
            ),
        ),
        'order_id'=>array(
            'columns'=>array(
                0=>'order_id',
            ),
        ),
        'order_bn'=>array(
            'columns'=>array(
                0=>'order_bn',
            ),
        ),
    ),
    'comment' => '订单发票表',
    'engine' => 'innodb',
    'version' => '$Rev:  $',
);