<?php
$db['order_setting']=array(
    'columns' =>
        array(
            'sid' => array(
                'type' => 'int unsigned',
                'required' => true,
                'pkey' => true,
                'editable' => false,
                'label' => '开票配置ID',
                'extra' => 'auto_increment',
            ),
            'payee_name' => array(
                    'type' => 'varchar(100)',
                    'label' => '开票方名称',
                    'in_list' => true,
                    'default_in_list' => true,
                    'width' => 130,
                    'order' => 5,
            ),
            'payee_operator' => array(
                    'type' => 'varchar(50)',
                    'label' => '开票人',
                    'in_list' => true,
                    'width' => 110,
            ),
            'content_id' => array(
                'type' => 'number',
                'default' => '1',
                'label' => '发票内容',
            ),
            'tax_rate' => array(
                'type' => 'tinyint(2)',
                'default' => '0',
                'label' => '税率',
                'in_list' => true,
                'default_in_list' => true,
                'width' => 60,
                'order' => 25,
            ),
            'tax_no' => array(
                'type' => 'varchar(32)',
                'label' => '开票方税号',
                'in_list' => true,
                'default_in_list' => true,
                'width' => 130,
                'order' => 10,
            ),
            'bank' => array(
                'type' => 'varchar(32)',
                'label' => '开票方开户银行',
                'in_list' => true,
                'width' => 110,
            ),
            'bank_no' => array(
                'type' => 'char(32)',
                'label' => '开票方银行账号',
                'in_list' => true,
                'width' => 120,
            ),
            'telephone' => array(
                'type' => 'char(32)',
                'label' => '开票方电话',
                'in_list' => true,
                'default_in_list' => true,
                'width' => 120,
                'order' => 20,
            ),
            'address' => array(
                'type' => 'varchar(255)',
                'label' => '开票方地址',
                'in_list' => true,
                'default_in_list' => true,
                'width' => 200,
                'order' => 15,
            ),
            'provider_appkey' => array(
                'type' => 'varchar(100)',
                'label' => '开票服务商的APPKEY',
//                 'in_list' => true,
//                 'default_in_list' => true,
//                 'width' => 60,
            ),
            'dateline' => array(
                'type' => 'time',
                'label' => '添加时间',
                'width' => 130,
                'in_list' => true,
                'default_in_list' => true,
                'filtertype' => 'time',
                'filterdefault' => true,
                'order' => 45,
            ),
            'shop_id' => array(
                'type' => 'table:shop@ome',
                'editable' => false,
                'label' => '电子发票来源店铺ID',
            ),
            'billing_shop_node_id' => array(
                'type' => 'varchar(32)',
                'editable' => false,
                'label' => '开票服务店铺节点号',
            ),
            'einvoice_operating_conditions' => array(
                'type' => array(
                    1=>'已发货',
                    2=>'已付款',
                ),
                'default' => 1,
                'editable' => false,
                'label' => '电子发票操作条件',
            ),
            'channel_id' =>array (
                'type' => 'table:channel@invoice',
                'label' => '开票来源',
                'width' => 130,
                'editable' => false,
                'filtertype' => 'normal',
                'filterdefault' => true,
                'filterdefault' => true,
                'in_list' => true,
                'default_in_list' => true,
                'order' => 35,
            ),
            'mode' => array(
                'type' => array(
                    0=>'纸质发票',
                    1=>'电子发票',
                ),
                'default' => '0',
                'label' => '开票方式',
                'in_list' => true,
                'order'=>30,
                'width' => 100,
            ),
            'status' =>
            array (
                'type' => 'bool',
                'default' => 'true',
                'editable' => false,
                'label' => '启用状态',
                'width' => '60',
                'in_list' => true,
                'default_in_list' => true,
                'order' => 40,
            ),
            'auto_bill' =>
            array (
                'type' => array(
                    0=>'关闭',
                    1=>'开启',
                ),
                'default' => '0',
                'editable' => false,
                'label' => '系统自动开票',
                'width' => '120',
                'in_list' => true,
            ),
            'auto_bill_timer' =>
            array (
                'type' => array(
                    1=>'商家发货后',
                    2=>'客户签收后',
                ),
                'default' => '1',
                'editable' => false,
                'label' => '自动开票时间点',
                'width' => '120',
                'in_list' => true,
            ),
            'force_tax_switch' =>
            array (
                'type' => array(
                    0=>'关闭',
                    1=>'开启',
                ),
                'default' => '0',
                'editable' => false,
                'label' => '强制开票开关',
                'width' => '120',
                'in_list' => true,
            ),
            'force_tax_title' =>
            array (
                'type' => 'varchar(150)',
                'editable' => false,
                'label' => '强制开票发票抬头',
                'width' => '130',
                'in_list' => true,
            ),
    ),
    'index' =>
    array (
        'ind_shop_id_update' =>
        array (
            'columns' =>
            array (
                    0 => 'shop_id',
            ),
        ),
        'ind_content_id' =>
        array (
            'columns' =>
            array (
                    0 => 'content_id',
            ),
        ),
        'ind_channel_id' =>
        array (
            'columns' =>
            array (
                    0 => 'channel_id',
            ),
        ),
        'ind_mode' =>
        array (
            'columns' =>
            array (
                    0 => 'mode',
            ),
        ),
        'ind_auto_bill' =>
        array (
            'columns' =>
            array (
                    0 => 'auto_bill',
            ),
        ),
        'ind_auto_bill_timer' =>
        array (
            'columns' =>
            array (
                    0 => 'auto_bill_timer',
            ),
        ),
        'ind_status' =>
        array (
            'columns' =>
            array (
                    0 => 'status',
            ),
        ),
    ),
    'comment' => '订单开票配置表',
    'engine' => 'innodb',
    'version' => '$Rev:  $',
);