<?php
class invoice_func{
    
    //获取电子发票来源
    public function channels($channel_type = ""){
        //目前只支持taobao
        $channels = array(
            'taobao'=>array('code'=>'taobao','name'=>'阿里淘宝'),
        );
        if($channel_type){
            return $channels[$channel_type];
        }
        return $channels;
    }
    
    /*
     * 电子发票自动开蓝票处理
     * $order_id 订单id
     * $auto_bill_timer 自动开票时间点  1 商家发货后   2 客户签收后
     * @param $queue 是否入队列 默认false
     */
    public function do_einvoice_bill($order_id,$auto_bill_timer,$queue=false){
        $mdlOmeOrders = app::get('ome')->model('orders');
        $rs_orders = $mdlOmeOrders->dump($order_id,"shop_id,status,ship_status");
        //自动开票时间点 是 商家发货后 存在拆单 故必须判断订单是 已完成 已发货的
        if($auto_bill_timer == "1"){
            if($rs_orders["status"] != "finish" || $rs_orders["ship_status"] != "1"){
                return false;
            }
        }
        //shop_id必要参数
        if(!$rs_orders["shop_id"]){
            return false;
        }
        //获取shop_id对应的自动开票配置
        $mdlInSetShopIdRel = app::get('invoice')->model('setting_shopid_relation');
        $rs_rel = $mdlInSetShopIdRel->dump(array("shop_id"=>$rs_orders["shop_id"]));
        if (empty($rs_rel)){
            return false;
        }
        $mdlInOrderSet = app::get('invoice')->model('order_setting');
        //电子发票配置 启用状态 自动开票开启 开票时间点
        $rs_set = $mdlInOrderSet->dump(array("sid"=>$rs_rel["sid"],"mode"=>"1","auto_bill"=>"1","auto_bill_timer"=>$auto_bill_timer,"status"=>"true"));
        if (empty($rs_set)){
            return false;
        }
        $mdlInOrder = app::get('invoice')->model('order');
        //获取订单对应的电子开票信息数据的主键id
        $arr_filter = array(
            "is_status" => "0",
            "mode" => "1",
            "sync" => array("0","2"),
            "order_id" => $order_id,
        );
        $rs_invoice_order = $mdlInOrder->dump($arr_filter);
        if (empty($rs_invoice_order)){
            return false;
        }
        $arr_billing = array(
            "id" => $rs_invoice_order["id"],
            "order_id" => $order_id,
        );
        kernel::single('invoice_process')->billing($arr_billing,$queue);
    }
    
}